package cz.uhk.wallboard.model;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class Prepocitavac {
	private static final Logger logger = LoggerFactory.getLogger(Prepocitavac.class);

	Map<String, Statistika> statistiky;

	public Prepocitavac(List<Statistika> statistiky) {
		this.statistiky = new HashMap<>();
		for (Statistika statistika : statistiky) {
			this.statistiky.put(statistika.getNazev(), statistika);
		}
	}

	public Prepocitavac() {
		super();
	}

	/**
	 * Ze vstupních statistik vypočítá všechy statistiky, které Wallboard zobrazuje, 
	 * ale stat server nesbírá (odvozené statistiky)
	 * 
	 * @return aktuální odvozené statistiky
	 */
	public Map<String, Statistika> vytvorOdvozeneStatistiky() {
		Map<String, Statistika> vysledek = new HashMap<String, Statistika>();
		for ( VypoctyObsluznostiKonkretnichUtvaru vypocet : 
				VypoctyObsluznostiKonkretnichUtvaru.values()) {
			OdvozenaStatistika obsluznost = vypocet.odvod(statistiky);
			vysledek.put(obsluznost.getNazev(), obsluznost);
		}
		return vysledek;
	}

	@Override
	public String toString() {
		return "Prepocitavac [mapa=" + statistiky + "]";
	}

}
