package cz.uhk.wallboard.model;

public class Statistika implements WallboardovaPolozka {
	private String nazev;
	private double hodnota;

	public Statistika(String nazev, double hodnota) {
		this.nazev = nazev;
		this.hodnota = hodnota;
	}

	public Statistika() {

	}

	public double getHodnota() {
		return hodnota;
	}

	@Override
	public String getNazev() {
		return nazev;
	}

	@Override
	public String getObsah() {
		return String.valueOf(hodnota);
	}

	@Override
	public String toString() {
		return "Statistika [nazev = " + nazev + ", hodnota = " + hodnota + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		long temp;
		temp = Double.doubleToLongBits(hodnota);
		result = prime * result + (int) (temp ^ (temp >>> 32));
		result = prime * result + ((nazev == null) ? 0 : nazev.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Statistika other = (Statistika) obj;
		if (Double.doubleToLongBits(hodnota) != Double.doubleToLongBits(other.hodnota))
			return false;
		if (nazev == null) {
			if (other.nazev != null)
				return false;
		} else if (!nazev.equals(other.nazev))
			return false;
		return true;
	}

}
