package cz.uhk.wallboard.model;

import java.util.ArrayList;
import java.util.Map;

/**
 * Implementuje výpočet obslužnosti linky
 *
 */
public class VypocetObsluznosti implements OdvozovaciStrategie {

	private String pocetObslouzenychHovoru;
	private String pocetVsechHovoru;
	private String nazevVysledku;

	public VypocetObsluznosti(String nazevStatistikyPocetObslouzenychHovoru,
			String nazevStatistikyPocetVsechHovoru, String nazevVysledneStatistikyObsluznosti) {
		this.pocetObslouzenychHovoru = nazevStatistikyPocetObslouzenychHovoru;
		this.pocetVsechHovoru = nazevStatistikyPocetVsechHovoru;
		this.nazevVysledku = nazevVysledneStatistikyObsluznosti;
	}

	@Override
	public OdvozenaStatistika odvod(Map<String, Statistika> statistika) {
		Statistika citatel = statistika.get(pocetObslouzenychHovoru);
		Statistika jmenovatel = statistika.get(pocetVsechHovoru);
		ArrayList<Statistika> zdrojovaStatistika = new ArrayList<>();
		zdrojovaStatistika.add(citatel);
		zdrojovaStatistika.add(jmenovatel);
		OdvozenaStatistika prepocitanaStatistika;

		if (jmenovatel != null && citatel != null && jmenovatel.getHodnota() != 0) {
			double hodnotaPrepocitaneStatistiky = citatel.getHodnota() / jmenovatel.getHodnota() * 100;
			prepocitanaStatistika = new OdvozenaStatistika(nazevVysledku, hodnotaPrepocitaneStatistiky,
					zdrojovaStatistika);
		} else {
			prepocitanaStatistika = new OdvozenaStatistika(nazevVysledku, Double.NaN, zdrojovaStatistika);
		}

		return prepocitanaStatistika;
	}

}
