package cz.uhk.wallboard.model;

import java.util.Map;

/**
 * 
 * Soustředí výpočty všech oblužností
 *
 */
public enum VypoctyObsluznostiKonkretnichUtvaru implements OdvozovaciStrategie {
	HDELB_CZ_IB_OBSLUZNOST {

		@Override
		public OdvozenaStatistika odvod(Map<String, Statistika> statistiky) {
			return Odvod("IB24ad", "IB24td", this.name(), statistiky);
		}
	},
	HDELB_CZ_BB_OBSLUZNOST {

		@Override
		public OdvozenaStatistika odvod(Map<String, Statistika> statistiky) {
			return Odvod("BB24ad", "BB24td", this.name(), statistiky);
		}
	},
	HDELB_PSB_IB_OBSLUZNOST {

		@Override
		public OdvozenaStatistika odvod(Map<String, Statistika> statistiky) {
			return Odvod("PSBIB24ad", "PSBIB24td", this.name(), statistiky);
		}
	},
	HDELB_HOMEBANKING_OBSLUZNOST {

		@Override
		public OdvozenaStatistika odvod(Map<String, Statistika> statistiky) {
			return Odvod("HBad", "HBtd", this.name(), statistiky);
		}
	},
	HDELB_MULTICASH_OBSLUZNOST {

		@Override
		public OdvozenaStatistika odvod(Map<String, Statistika> statistiky) {
			return Odvod("MCad", "MCtd", this.name(), statistiky);
		}
	},
	HDELB_EDIFAC_OBSLUZNOST {

		@Override
		public OdvozenaStatistika odvod(Map<String, Statistika> statistiky) {
			return Odvod("MCad", "MCtd", this.name(), statistiky);
		}
	},
	CSOB_INFOLINKA_OBSLUZNOST {

		@Override
		public OdvozenaStatistika odvod(Map<String, Statistika> statistiky) {
			return Odvod("CSOBad", "CSOBtd", this.name(), statistiky);
		}
	},
	ERA_INFOLINKA_OBSLUZNOST {

		@Override
		public OdvozenaStatistika odvod(Map<String, Statistika> statistiky) {
			return Odvod("PSINFad", "PSINFtd", this.name(), statistiky);
		}
	};

	private static OdvozenaStatistika Odvod(String nazevPoctuOblouzenych, String nazevCelkevhoPoctu,
			String nazevVysledku, Map<String, Statistika> statistiky) {
		VypocetObsluznosti vypocitejIB = new VypocetObsluznosti(nazevPoctuOblouzenych, nazevCelkevhoPoctu,
				nazevVysledku);
		OdvozenaStatistika vysledek = vypocitejIB.odvod(statistiky);
		return vysledek;
	}

}
