package cz.uhk.wallboard.security;

public abstract class Operation {
	private String name;
	private Permission permission;
	private Object object;

	public Operation(String name, Permission permission, Object object) {
		super();
		this.name = name;
		this.object = object;
		this.permission = permission;
	}

	public abstract void perform();

	public abstract Operation zkopirujSe();

	public boolean isAuthorized() {
		return getPermission().checkPermission();
	}

	public String getName() {
		return name;
	}

	public Permission getPermission() {
		return permission;
	}

	public void setPermission(Permission permission) {
		this.permission = permission;
	}

	public Object getObject() {
		return object;
	}

	public void setObject(Object object) {
		this.object = object;
	}

	@Override
	public String toString() {
		return "Operation [name=" + name + ", permission=" + permission + ", object=" + object + "]";
	}

}
