package cz.uhk.wallboard.security;

import java.util.Collection;

import cz.uhk.wallboard.services.WallboardUserService;

/**
 * Kontroluje, zda má aktuální uživatel všechny dané role.
 *
 */
public class PermissionKontrolujiciRole implements Permission {

	private Collection<? extends Role> nutneRole;
	private WallboardUserService wallboardUserService;

	public PermissionKontrolujiciRole(Collection<? extends Role> nutneRole, WallboardUserService wallboardUserService) {
		super();
		this.nutneRole = nutneRole;
		this.wallboardUserService = wallboardUserService;
	}

	/**
	 * Kontroluje oprávnění podle rolí současného uživatele.
	 */
	@Override
	public boolean checkPermission() {
		WallboardUser user = wallboardUserService.getCurrentUser();
		return user.getRole().containsAll(nutneRole);
	}

	@Override
	public String toString() {
		return "PermissionKontrolujiciRole [nutneRole=" + nutneRole + ", wallboardUserService=" + wallboardUserService
				+ "]";
	}

}
