package cz.uhk.wallboard.security;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Anotace pro definici uzivatele, ktery se ma fiktivne prihlasit (napriklad jUnit testy, kde fintivni prihlaseni provadi jUnit test listener RunAsSupportTestExecutionListener)
 */
@Target({ ElementType.METHOD })
@Retention(RetentionPolicy.RUNTIME)
@Documented
public @interface RunAsUser {

	/**
	 * Login nebo jmeno ve windows, napriklad glow001\jd47505
	 */
	String principalName();

	/**
	 * Pridelene role danemu uzivateli. Napriklad ROLE_USER, ROLE_ADMIN
	 */
	String[] roles();

}