package cz.uhk.wallboard.security;

import org.springframework.beans.factory.annotation.Autowired;

import cz.uhk.wallboard.model.Zprava;
import cz.uhk.wallboard.services.ZpravaService;

public class UlozZpravuOperation extends Operation {
	private Zprava ukladanaZprava;

	@Autowired
	public UlozZpravuOperation(String name, Permission permission, ZpravaService zpravaService) {
		super(name, permission, zpravaService);
	}

	@Override
	public void perform() {
		if (ukladanaZprava == null) {
			throw new IllegalStateException("Ukládaná zpráva je null.");
		}
		((ZpravaService) getObject()).save(ukladanaZprava);
	}

	@Override
	public Operation zkopirujSe() {
		UlozZpravuOperation vysledek = new UlozZpravuOperation(getName(), 
				getPermission(), (ZpravaService) getObject());
		vysledek.setUkladanaZprava(ukladanaZprava);
		return vysledek;
	}

	public Zprava getUkladanaZprava() {
		return ukladanaZprava;
	}

	public void setUkladanaZprava(Zprava ukladanaZprava) {
		this.ukladanaZprava = ukladanaZprava;
	}

}
