package cz.uhk.wallboard.server;

import java.text.NumberFormat;
import java.util.Date;
import java.util.Timer;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import cz.uhk.wallboard.services.Task;

public class ApplicationListener implements ServletContextListener {
	Timer timer;

	@Override
	public void contextInitialized(ServletContextEvent event) {
		NumberFormat formatCisla = NumberFormat.getInstance();
		formatCisla.setMaximumFractionDigits(2);
		event.getServletContext().setAttribute("format", formatCisla);
		NumberFormat celociselnyFormat = NumberFormat.getInstance();
		celociselnyFormat.setMaximumFractionDigits(0);
		event.getServletContext().setAttribute("celociselnyFormat", celociselnyFormat);

		// Spustit opakovane nacitani statistik
		Task task = new Task(event.getServletContext());
		timer = new java.util.Timer();
		String milisekundMeziDotazyNaStatistiky = event.getServletContext()
				.getInitParameter("milisekundMeziDotazyNaStatistiky");
		int milisekundMeziDotazyNaStatistikyInt = Integer.parseInt(milisekundMeziDotazyNaStatistiky);
		timer.schedule(task, new Date(), milisekundMeziDotazyNaStatistikyInt);

	}

	@Override
	public void contextDestroyed(ServletContextEvent sce) {
		timer.cancel();

	}

}
