package cz.uhk.wallboard.services.impl;

import java.util.ArrayList;
import java.util.List;

import org.springframework.security.core.Authentication;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.stereotype.Component;

import cz.uhk.wallboard.security.Role;
import cz.uhk.wallboard.security.WallboardUser;
import cz.uhk.wallboard.services.WallboardUserService;

@Component(value = "WallboardUserService")
public class WallboardUserServiceImpl implements WallboardUserService {

	@Override
	public WallboardUser getCurrentUser() {
		Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
		List<Role> role = new ArrayList<Role>();
		for (GrantedAuthority grantedAuthority : authentication.getAuthorities()) {
			String authority = grantedAuthority.getAuthority();
			if (authority != null) {
				// nektere grantedAuthority mohou vracet null (pokud jsou tzv. komplexni, coz se wallboardu asi netyka)
				// https://docs.spring.io/spring-security/site/docs/current/reference/html/authz-arch.html
				role.add(new Role(authority));
			}
		}
		WallboardUser result = new WallboardUser(authentication.getName(), role);
		return result;
	}
}
