package cz.uhk.wallboard.services.impl;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import cz.uhk.wallboard.dal.ZpravaDao;
import cz.uhk.wallboard.model.TypZpravy;
import cz.uhk.wallboard.model.Zprava;
import cz.uhk.wallboard.services.WallboardUserService;
import cz.uhk.wallboard.services.ZpravaService;

@Component
public class ZpravaServiceImpl implements ZpravaService {

	private ZpravaDao zpravaDao;
	private WallboardUserService wallboardUserService;

	@Autowired
	public ZpravaServiceImpl(ZpravaDao zpravaDao, WallboardUserService wallboardUserService) {
		this.zpravaDao = zpravaDao;
		this.wallboardUserService = wallboardUserService;
	}

	@Override
	public void save(Zprava ukladana) {
		zpravaDao.insert(ukladana, wallboardUserService.getCurrentUser().getUsername(), new Date());
	}

	@Override
	public Zprava getZprava(int idZpravy) {
		// TODO nacist z databaze, ale zatim se nepouziva, tak spis smazat?
		return new Zprava(1, "testovaci zprava z ZpravaService", "testovaci obsah zpravy ze zprava service",
				TypZpravy.LEKTORSKA);
	}

	@Override
	public Zprava getNejaktualnejsiZpravuPodleNazvu(String nazevZpravy) {
		return zpravaDao.getNejnovejsiZpravaPodleNazvu(nazevZpravy);
	}

	@Override
	public List<Zprava> getViditelneZpravy() {
		List<Zprava> vysledek = zpravaDao.getNejnovejsiZpravy();
		// jak to udelam, kdyz nejake jmeno uz nebude zobrazovano?
		return vysledek;
	}

}
