package cz.uhk.wallboard.dal;

import java.util.Date;
import java.util.List;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.util.Assert;

import cz.uhk.wallboard.model.TypZpravy;
import cz.uhk.wallboard.model.Zprava;
import cz.uhk.wallboard.services.ZpravaService;

@ContextConfiguration(locations = { "/integrationContextTest.xml" })
@RunWith(SpringJUnit4ClassRunner.class)
public class ZpravaDaoTest {

	@Autowired
	ZpravaDao zpravaDao;

	@Autowired
	ZpravaService zpravaService;

	@Test
	public void nejnovejsiZpravySeNactou() {
		List<Zprava> nejnovejsiZpravy = zpravaDao.getNejnovejsiZpravy();
		Assert.notEmpty(nejnovejsiZpravy);
	}

	@Test
	public void kdyzZpravuVlozim_TakJiPakZaseNactu() {
		Zprava ukladana = new Zprava(0, "testovaci", "obsah", TypZpravy.MANAZERSKA);
		zpravaDao.insert(ukladana, "test", new Date());
		Zprava nactena = zpravaDao.getNejnovejsiZpravaPodleNazvu("testovaci");
		Assert.isTrue(ukladana.getNazev().equals(nactena.getNazev()));
		Assert.isTrue(ukladana.getObsah().equals(nactena.getObsah()));
		Assert.isTrue(ukladana.getTypZpravy().equals(nactena.getTypZpravy()));
	}

}
