package cz.uhk.wallboard.model;

import static org.junit.Assert.assertEquals;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import org.junit.Test;

public class PrepocitavacTest {

	@Test
	public void kdyzBudouStatistikyPrazdne_TakPrepocitavacNespadne() {
		ArrayList<Statistika> statistiky = new ArrayList<>();
		new Prepocitavac(statistiky);
	}

	@Test
	public void kdyzBudouStatistikyPrazdne_TakPrepocitavacVratiStatistikyPrazdneAleExistujici() {
		ArrayList<Statistika> statistiky = new ArrayList<>();
		Prepocitavac prepocitavac = new Prepocitavac(statistiky);
		// Map prepocitej = prepocitavac.prepocitej();
		Map<String, OdvozenaStatistika> expected = new HashMap<String, OdvozenaStatistika>();
		for (VypoctyObsluznostiKonkretnichUtvaru vypocetObsluznosti : VypoctyObsluznostiKonkretnichUtvaru.values()) {
			ArrayList<Statistika> zdrojoveStatistiky = new ArrayList<>();
			zdrojoveStatistiky.add(null); // vstup je prazdny, statistiky nebudou nalezeny
			zdrojoveStatistiky.add(null);
			expected.put(vypocetObsluznosti.name(),
					new OdvozenaStatistika(vypocetObsluznosti.name(), Double.NaN, zdrojoveStatistiky));
		}

		Map<String, Statistika> actual = prepocitavac.vytvorOdvozeneStatistiky();
		assertEquals("prepocitavac musi vracet mapu Statistik", actual, expected);
	}

	@Test
	public void kdyzBudouZadanyZdrojoveStatistiky_TakSeSpocitaObsluznost() {
		ArrayList<Statistika> statistiky = new ArrayList<>();
		Statistika pocetObslouzenych = new Statistika("IB24ad", 9);
		statistiky.add(pocetObslouzenych);
		Statistika pocetVolajicich = new Statistika("IB24td", 10);
		statistiky.add(pocetVolajicich);

		Prepocitavac prepocitavac = new Prepocitavac(statistiky);
		// Map prepocitej = prepocitavac.prepocitej();
		Map<String, OdvozenaStatistika> expected = new HashMap<String, OdvozenaStatistika>();
		for (VypoctyObsluznostiKonkretnichUtvaru vypocetObsluznosti : VypoctyObsluznostiKonkretnichUtvaru.values()) {
			ArrayList<Statistika> zdrojoveStatistiky = new ArrayList<Statistika>() {
			};
			zdrojoveStatistiky.add(null); // vstup je prazdny, statistiky nebudou nalezeny, protoze je vstup neobsahuje
			zdrojoveStatistiky.add(null);
			expected.put(vypocetObsluznosti.name(),
					new OdvozenaStatistika(vypocetObsluznosti.name(), Double.NaN, zdrojoveStatistiky));
		}
		expected.put(VypoctyObsluznostiKonkretnichUtvaru.HDELB_CZ_IB_OBSLUZNOST.name(), new OdvozenaStatistika(
				VypoctyObsluznostiKonkretnichUtvaru.HDELB_CZ_IB_OBSLUZNOST.name(), (9.0 / 10) * 100, statistiky));

		Map<String, Statistika> actual = prepocitavac.vytvorOdvozeneStatistiky();
		assertEquals("prepocitavac musi vracet mapu Statistik", expected, actual);
	}
}
