package cz.uhk.wallboard.security;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.TestExecutionListeners;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.test.context.support.DependencyInjectionTestExecutionListener;
import org.springframework.test.context.support.DirtiesContextTestExecutionListener;

import cz.uhk.wallboard.controller.ZpravaController;
import cz.uhk.wallboard.model.TypZpravy;
import cz.uhk.wallboard.model.Zprava;

@ContextConfiguration(locations = { "/integrationContextTest.xml" })
@RunWith(SpringJUnit4ClassRunner.class)
@TestExecutionListeners({ DependencyInjectionTestExecutionListener.class, DirtiesContextTestExecutionListener.class,
		RunAsSupportTestExecutionListener.class })
public class OperationManagerTest // extends AbstractTransactionalJUnit4SpringContextTests
{

	@Autowired
	ZpravaController zpravaController;

	@Test
	@RunAsUser(principalName = "glow001\\jd47505", roles = { "GLOW001\\0002_GS_B4_KC_HDELB" })
	public void uzivatelSRoliManazeraHdElbMuzeUlozitManazerskouZpravuProHdElb() throws Exception {
		Zprava ukladana = new Zprava(0, "hdelb", "obsah", TypZpravy.MANAZERSKA);
		zpravaController.novaZprava(ukladana.getNazev(), ukladana.getObsah(),
				ukladana.getTypZpravy().getNazevBezDiakritiky());
	}

	@Test(expected = org.springframework.security.access.AccessDeniedException.class)
	@RunAsUser(principalName = "glow001\\jd47505", roles = { "GLOW001\\0002_GS_B4_KC_HDELB" })
	public void uzivatelSRoliManazeraHdElbNemuzeUlozitLektorskouZpravuProHdElb() throws Exception {
		Zprava ukladana = new Zprava(0, "hdelb", "obsah", TypZpravy.LEKTORSKA);
		zpravaController.novaZprava(ukladana.getNazev(), ukladana.getObsah(),
				ukladana.getTypZpravy().getNazevBezDiakritiky());
	}

	@Test
	@RunAsUser(principalName = "glow001\\jd47505", roles = { "GLOW001\\0002_GS_LEKTOR_ELB" })
	public void uzivatelSRoliLektoraHdElbMuzeUlozitLektorskouZpravuProHdElb() throws Exception {
		Zprava ukladana = new Zprava(0, "hdelb", "obsah", TypZpravy.LEKTORSKA);
		zpravaController.novaZprava(ukladana.getNazev(), ukladana.getObsah(),
				ukladana.getTypZpravy().getNazevBezDiakritiky());
	}

	@Test(expected = org.springframework.security.access.AccessDeniedException.class)
	@RunAsUser(principalName = "glow001\\jd47505", roles = { "GLOW001\\0002_GS_LEKTOR_ELB" })
	public void uzivatelSRoliLektoraHdElbNemuzeUlozitManazerskouZpravuProHdElb() throws Exception {
		Zprava ukladana = new Zprava(0, "hdelb", "obsah", TypZpravy.MANAZERSKA);
		zpravaController.novaZprava(ukladana.getNazev(), ukladana.getObsah(),
				ukladana.getTypZpravy().getNazevBezDiakritiky());
	}

}
